/* --------------------------------------------------------------------------------------------------------------------
                                            CURSO DE PROGRAMAO EM PL-SQL
                                                  PEDRO F. CARVALHO
                                              www.pedrofcarvalho.com.br
                                            contato@pedrofcarvalho.com.br
                                              ORACLE 9i, 10G, 11G E 12C
                         Preparao para a prova 1Z0-147 e 1Z0-144 e 1Z0-146 Program with PL/SQL  
----------------------------------------------------------------------------------------------------------------------*/


Captulo 01 - Introduo a Linguagem PL-SQL.

1 - Introduo
________________________________________________________________________________________________________________________

PL/SQL (acrnimo para a expresso inglesa Procedural Language/Structured Query Language)  uma extenso da linguagem 
padro SQL para o SGBD Oracle da Oracle Corporation.  uma linguagem procedural da Oracle que estende a linguagem 
SQL.

PL/SQL  uma linguagem de programao baseada em opes monogrficas de edio. Ela  composta por trs camadas, 
definio, edio, e concluso.

Permite que a manipulao de dados seja includa em unidades de programas. Blocos de PL/SQL so passados e processados 
por uma PL/SQL Engine que pode estar dentro de uma ferramenta Oracle ou do Server. A PL/SQL Engine filtra os comandos 
SQL e manda individualmente o comando SQL para o SQL Statement Executor no Oracle Server, que processa o PL/SQL com 
os dados retornados do Server.

 a linguagem bsica para criar programas complexos e poderosos, no s no banco de dados, mas tambm em diversas 
ferramentas Oracle.

Antes de 1991 a nica forma de usar construes procedurais com o SQL era usar PRO*C. Foi onde as instrues SQL do 
Oracle foram embutidas em cdigo C. O cdigo C era pr-compilado para converter as instrues SQL em chamadas de 
bibliotecas.

Em 1991 o PL/SQL 1.0 foi lanado com o Oracle Verso 6.0. Ele era muito limitado nas suas capacidades.



2 - Necessidade
________________________________________________________________________________________________________________________

Implementar uma estrutura de codificao que auxilie a linguagem SQL e que oferea recursos de comunicao com o
banco , programas externos e etc suficiente.


  
3 - Benefcios
________________________________________________________________________________________________________________________

Uma das principais vantagens da linguagem PL/SQL  permitir que voc escreva programas que ficam armazenados no banco 
de dados e que podem ser reutilizados por qualquer aplicao/usurio que acesse o banco. Segundo Thomas Kyte, um dos 
maiores especialistas em Oracle do mundo, PL/SQL  a forma mais rpida de processar dados em Bancos de Dados Oracle.
Entenda processar dados como no apenas submeter instrues SQL (UPDATE, SELECT, INSERT e DELETE) para o banco, 
mas sim, efetuar transaes que consistem de vrias estruturas de deciso, loops e outros tipos de processamento.

Pode ser usado para agrupar vrias perguntas SQL num s bloco e envi-lo de uma s vez para o servidor.

PL/SQL pode cooperar com as ferramentas de desenvolvimento de aplicaes Oracle tais como Developer Forms e Reports 
adicionando poder de processamento procedimental a estas ferramentas.

Podemos tirar vantagens das capacidades procedimentais  do PL/SQL que no esto presentes no SQL.

Pode-se escrever programas e criar bibliotecas que podem ser reutilizadas em diferentes ambientes.

Pode-se declarar variveis dinamicamente baseadas em estruturas de dados ou tabelas e colunas da BD (%TYPE, %ROWTYPE)

Desenvolvimento modular de programas.

Permite executar instrues condicionais.

Permite executar instrues num ciclo.

Permite processar vrias linhas devolvidas por uma pergunta atravs de cursores.

Os erros podem ser processados com rotinas de tratamento de excepes.

...


4 - Identificar os componentes bloco PL-SQL
________________________________________________________________________________________________________________________


DECLARE     -- secao de declaracoes
    V_CONT NUMBER;  -- declaracao de variavel
BEGIN       -- secao executavel
    
            -- regras de negcio
            
            
EXCEPTION  -- secao de tratamento de excecao
    WHEN OTHERS THEN -- se houver erros no cdigo de negcio aqui aparecer as mensagens de erros tratadas
        
END;


5 - Output message em PL-SQL
________________________________________________________________________________________________________________________

create table hr.funcionario (id integer, nome varchar(50), idade integer);
insert into hr.funcionario values (1, 'PEDRO CARVALHO', 37);
commit;

SET SERVEROUTPUT ON
DECLARE     -- secao de declaracoes
    V_NOME hr.funcionario.nome%type;  -- declaracao de variavel

BEGIN       -- secao executavel
   
    SELECT  NOME INTO V_NOME 
    FROM    HR.FUNCIONARIO
    WHERE ID = 1; -- instrucao SQL 
  
    DBMS_OUTPUT.PUT_LINE('Funcionario ' || V_NOME || ' cadastrado com sucesso');
    
EXCEPTION  -- secao de tratamento de excecao
    WHEN OTHERS THEN
        DBMS_OUTPUT.PUT_LINE(SQLERRM);
END;

drop table hr.funcionario;


