
/* --------------------------------------------------------------------------------------------------------------------
                                            CURSO DE PROGRAMAO EM PL-SQL
                                                  PEDRO F. CARVALHO
                                              www.pedrofcarvalho.com.br
                                            contato@pedrofcarvalho.com.br
                                              ORACLE 9i, 10G, 11G E 12C
                         Preparao para a prova 1Z0-147 e 1Z0-144 e 1Z0-146 Program with PL/SQL  
----------------------------------------------------------------------------------------------------------------------*/


Captulo 04 - Estruturas de Controle.

Estruturas de Deciso.

IF .. END IF
 utilizado para permitir que o fluxo do programa seja desviado para um determinado ponto da lgica, conforme o 
resultado de uma comparao feita. Existem 3 variaes desta estrutura, cobrindo desde o caso mais simples at 
possibilidades de desvio mltiplo.

-- IF simples
SET SERVEROUTPUT ON
DECLARE
  v_count NUMBER;
BEGIN
  SELECT  COUNT(1) INTO V_COUNT
  FROM    HR.EMPLOYEES;

  IF V_COUNT = 0 THEN
    DBMS_OUTPUT.PUT_LINE('Nao existem funcionrios.');
  END IF;
  DBMS_OUTPUT.PUT_LINE(V_COUNT);
END;

SET SERVEROUTPUT ON
DECLARE
  v_count NUMBER;
BEGIN
  SELECT  COUNT(1) INTO V_COUNT
  FROM    HR.EMPLOYEES;

  IF V_COUNT = 0 THEN
    DBMS_OUTPUT.PUT_LINE('Nao existem funcionarios.');
  ELSE
    DBMS_OUTPUT.PUT_LINE('Existem ' || TO_CHAR(v_count) || ' funcionarios.');
  END IF;
END;

SET SERVEROUTPUT ON
DECLARE
  v_count NUMBER;
BEGIN
  SELECT  COUNT(1) INTO V_COUNT
  FROM    HR.EMPLOYEES;

  IF V_COUNT = 0 THEN
    DBMS_OUTPUT.PUT_LINE('Nao existem funcionarios.');
  ELSIF V_COUNT > 50 THEN
    DBMS_OUTPUT.PUT_LINE('Existem mais de 50 empregados cadastrados.');
  ELSIF V_COUNT < 50 THEN
    DBMS_OUTPUT.PUT_LINE('Existem menos de 50 empregados cadastrados.');
  ELSE
    DBMS_OUTPUT.PUT_LINE('Existem ' || TO_CHAR(v_count) || ' funcionarios.');
  END IF;  
END;

SET SERVEROUTPUT ON
DECLARE
  V_COUNT NUMBER;
BEGIN
  SELECT  COUNT(1) INTO V_COUNT
  FROM    HR.EMPLOYEES;

  CASE V_COUNT  -- somente de igualdade
        WHEN 0 THEN DBMS_OUTPUT.PUT_LINE('Nao existem funcionarios.');
        ELSE DBMS_OUTPUT.PUT_LINE('Existem ' || TO_CHAR(V_COUNT) || ' funcionarios.');
  END CASE;  
END;

-- case com seletor dando criterio para a condio
SET SERVEROUTPUT ON
DECLARE
  V_COUNT NUMBER;
BEGIN
  SELECT  COUNT(1) INTO V_COUNT
  FROM    HR.EMPLOYEES;

  CASE 
        WHEN V_COUNT <> 0  THEN DBMS_OUTPUT.PUT_LINE('Nao existem funcionarios.');
        ELSE DBMS_OUTPUT.PUT_LINE('Existem ' || TO_CHAR(V_COUNT) || ' funcionarios.');
  END CASE;  
END;

SET SERVEROUTPUT ON
DECLARE
  V_COUNT NUMBER;
  v_msg VARCHAR2(100);
BEGIN
  SELECT  COUNT(1) INTO V_COUNT
  FROM    HR.EMPLOYEES;

  V_MSG:=   CASE 
              WHEN V_COUNT = 0 THEN 'Nao existem funcionarios.'
              WHEN V_COUNT > 100 THEN 'Existem mais de 100 funcionarios.'
              ELSE 'Existem ' || TO_CHAR(v_count) || ' funcionarios.'
            END;

  DBMS_OUTPUT.PUT_LINE(v_msg);
END;

 explain plan for
  SELECT COUNT (CASE WHEN salary < 1000 
                     THEN 1 ELSE null END) count1, 
         COUNT (CASE WHEN salary BETWEEN 1001 AND 3000 
                     THEN 1 ELSE null END) count2, 
         COUNT (CASE WHEN salary > 3000 
                   THEN 1 ELSE NULL END) COUNT3 
  FROM  HR.EMPLOYEES;
  select * from table(dbms_xplan.display);
  
 explain plan for  
-- a instrucao acima eh similar a instrucao abaixo, mas retorna resultado em colunas ao inves de linhas  
  SELECT  COUNT(1) 
  FROM    HR.EMPLOYEES
  WHERE   SALARY < 1000
  UNION ALL
  SELECT  COUNT(1) 
  FROM    HR.EMPLOYEES
  WHERE   SALARY BETWEEN 1001 AND 3000
  UNION ALL
  SELECT  COUNT(1) 
  FROM    HR.EMPLOYEES
  WHERE   salary > 3000;
 select * from table(dbms_xplan.display);

-- Obs.: se a condicao avaliada retornar um valor nulo, o bloco ELSE  quem seria executado, quando ele existir.
-- diferena count(*), count(1),  nenhuma diferena
-- count(coluna) valores nulos nao sao contabilizados.
-- dicas performance se nao usar o to_char ele pode usar erro em sql faa voce mesmo as convesoes

Estruturas de Repetio.

LOOP ... EXIT [WHEN ...] ... END LOOP
 uma estrutura de repetio simples, cuja sada  indicada pela instruo EXIT.  possvel testar a condio de sada 
atravs de uma estrutura IF / END IF conforme o exemplo abaixo ou, como  mais recomendvel, atravs da clusula 
opcional WHEN na prpria instruo EXIT.

WHILE ... LOOP ... END LOOP
O ciclo de iteraes  executado enquanto a condio da clusula WHILE for verdadeira.

FOR... IN ... LOOP ... END LOOP
O ciclo de iteraes  executado um nmero predefinido de vezes, controlado por meio de um contador.

SET SERVEROUTPUT ON
DECLARE 
  V_COUNT NUMBER:=0;
BEGIN
  FOR I IN 1..100 LOOP
 --   FOR I IN reverse 1..100 LOOP
    V_COUNT:=V_COUNT+1;
 --   EXIT WHEN V_COUNT = 90;
  END LOOP;
  
  DBMS_OUTPUT.PUT_LINE('Final de V_COUNT: ' || V_COUNT);
END;

SET SERVEROUTPUT ON  -- vai funcionar ....
DECLARE 
  V_COUNT NUMBER:=0;
BEGIN
  FOR I IN 1..100 LOOP
 -- FOR V_COUNT IN reverse 1..100 LOOP
    null;
  END LOOP;  -- deu erro porque a v_count  filha, tem que usar identificador de bloco
  
  DBMS_OUTPUT.PUT_LINE('Final de V_COUNT: ' || V_COUNT);
END;


SET SERVEROUTPUT ON  -- vai funcionar ....
DECLARE 
  V_COUNT NUMBER:=0;
BEGIN
 -- FOR I IN 1..100 LOOP
  FOR i IN reverse 1..100 LOOP
    V_COUNT:=V_COUNT+1;
  END LOOP;
  
  DBMS_OUTPUT.PUT_LINE('Valor final de V_COUNT: ' || V_COUNT);
END;

SET SERVEROUTPUT ON
DECLARE 
  V_COUNT NUMBER:=0;
BEGIN
  LOOP -- vai entrar sempre a primeira condiao
    V_COUNT:=V_COUNT+1;
    EXIT WHEN V_COUNT = 100;
  END LOOP;
  
  DBMS_OUTPUT.PUT_LINE('Valor final de V_COUNT: ' || V_COUNT);
END;

SET SERVEROUTPUT ON
DECLARE 
  V_COUNT NUMBER:=0;
BEGIN
  WHILE V_COUNT < 100 LOOP-- executa quando for verdadeira no inicio
    V_COUNT:=V_COUNT+1;    
  END LOOP;
  
  DBMS_OUTPUT.PUT_LINE('Valor final de V_COUNT: ' || V_COUNT);
END;

SET SERVEROUTPUT ON
DECLARE 
  V_COUNT NUMBER:=1;
BEGIN
  <<pai>>
  FOR I IN 1..1000 LOOP
    <<filho>>
    LOOP
      EXIT pai WHEN V_COUNT > 10;
      EXIT filho WHEN MOD(V_COUNT,10)=0;
      V_COUNT:=V_COUNT+1;
    END LOOP filho;
    
    V_COUNT:=V_COUNT+1;
  END LOOP pai;
  
  DBMS_OUTPUT.PUT_LINE('Valor de V_COUNT: ' || V_COUNT);
END;

-- nunca comparar 10 <> null errado no compara nao entra nulo nao pode ter comparao

-- 1: TESTE DE COMPARACOES LOGICAS
set serveroutput on
declare
  v_resultado boolean;
  v_compare1 boolean;
  v_compare2 boolean;
begin
    --AND 1 (true and true)
    v_compare1 := true;
    v_compare2 := true;
    v_resultado := v_compare1 AND v_compare2;
    dbms_output.put_line('AND 1 (true and true): Valor de v_resultado = ' || case v_resultado when true then 'true' when false then 'false' else 'null' end);
    
    --AND 2 (true and false)
    v_compare1 := true;
    v_compare2 := false;
    v_resultado := v_compare1 AND v_compare2;
    dbms_output.put_line('AND 2 (true and false): Valor de v_resultado = ' || case v_resultado when true then 'true' when false then 'false' else 'null' end);
    
    --AND 3 (null and true)
    v_compare1 := null;
    v_compare2 := true;
    v_resultado := v_compare1 AND v_compare2;
    dbms_output.put_line('AND 3 (null and true): Valor de v_resultado = ' || case v_resultado when true then 'true' when false then 'false' else 'null' end);
    
    --AND 4 (null and false)
    v_compare1 := null;
    v_compare2 := false;
    v_resultado := v_compare1 AND v_compare2;
    dbms_output.put_line('AND 4 (null and false): Valor de v_resultado = ' || case v_resultado when true then 'true' when false then 'false' else 'null' end);
     
    --OR 1 (true and true)
    v_compare1 := true;
    v_compare2 := true;
    v_resultado := v_compare1 OR v_compare2;
    dbms_output.put_line('OR 1 (true and true): Valor de v_resultado = ' || case v_resultado when true then 'true' when false then 'false' else 'null' end);
    
    --OR 2 (true and false)
    v_compare1 := true;
    v_compare2 := false;
    v_resultado := v_compare1 OR v_compare2;
    DBMS_OUTPUT.PUT_LINE('OR 2 (true and false): Valor de v_resultado = ' || CASE V_RESULTADO WHEN TRUE THEN 'true' WHEN FALSE THEN 'false' ELSE 'null' END);
    
    --OR 3 (null and true)
    v_compare1 := null;
    v_compare2 := true;
    v_resultado := v_compare1 OR v_compare2;
    dbms_output.put_line('OR 3 (null and true): Valor de v_resultado = ' || case v_resultado when true then 'true' when false then 'false' else 'null' end);
    
    --OR 4 (null and false)
    v_compare1 := null;
    v_compare2 := false;
    v_resultado := v_compare1 OR v_compare2;
    dbms_output.put_line('OR 4 (null and false): Valor de v_resultado = ' || case v_resultado when true then 'true' when false then 'false' else 'null' end);
end;

-- 2: TESTE DE COMPARACOES LOGICAS entre 2 valores nulos
set serveroutput on
declare  
  v_resultado boolean := null;
  v_compare1 boolean := NULL;
  v_compare2 boolean := NULL;
begin
  v_resultado := (v_compare1 = v_compare2);  

  if v_resultado = true then
    DBMS_OUTPUT.PUT_LINE('true');
  elsif v_resultado = false then
    DBMS_OUTPUT.PUT_LINE('false');
  elsif v_resultado is null then
    DBMS_OUTPUT.PUT_LINE('null');
  end if;
end;


-- 3: Teste em que ocorre resultado inesperado pela falta de tratamento de valor nulo
SET SERVEROUTPUT ON
DECLARE 
  V_COUNT NUMBER:=0;
  V_INICIO NUMBER:=1;
  V_FIM NUMBER:= CASE V_INICIO
                      WHEN 0 THEN 100 -- linha q pode ser alterada p/ mudar condicao do loop (substituir 0 por 1 para entrar no loop)
                      ELSE  NULL
                  END;
BEGIN
  WHILE (V_COUNT <> V_FIM) -- a comparacao executa a mesma logica do operador AND, portanto ao comparar 2 variaveis se 1 delas for <> de nulo o resultado  false
  LOOP
    V_COUNT:=V_COUNT+1;
  END LOOP;
  
  DBMS_OUTPUT.PUT_LINE('O valor final de V_COUNT eh: ' || V_COUNT);
END;








