/* --------------------------------------------------------------------------------------------------------------------
                                            CURSO DE PROGRAMAO EM PL-SQL
                                                  PEDRO F. CARVALHO
                                              www.pedrofcarvalho.com.br
                                            contato@pedrofcarvalho.com.br
                                              ORACLE 9i, 10G, 11G E 12C
                         Preparao para a prova 1Z0-147 e 1Z0-144 e 1Z0-146 Program with PL/SQL  
----------------------------------------------------------------------------------------------------------------------*/


Captulo 05 - Composite Data Types Colletions

Diferena entre Colletions e Cursores

SQL puro  sempre mais eficiente do que utilizar um cursor ou  uma collection.

Collections so normalmente uma boa opo para efetuar cargas de dados em massa (bulk binding) pois neste processo ele
traz o tamanho do seus dml para dentro da memria, isto  se seu select vai trazer 5 giga de dados e se sua memria
contiver apenas 4 ira ter problemas de travamento.

Cursores normalmente so uma boa opo para economizar memria do SGBD. 

Uma collection nada mais  que uma estrutura tridimensional nica e homognea, o que constitui um conjunto ordenado de 
elementos de um determinado tipo similar. Sendo uma estrutura homognea, todos os elementos so do mesmo tipo de dados. 
A estrutura do elemento contm clulas com um subscrito. Os elementos residem nestas clulas para fazer o ndice como 
sendo a sua informao de localizao. O ndice subscrito ou clula torna-se de fato, a identificao de um elemento 
e  utilizada para o seu acesso.

Vantagens

fornecer a melhoria no desempenho das aplicaes. Ns desenvolvedores utilizaramos colees para dados estticos 
'cache' que precisam ser acessados ?? regularmente. Isso resultaria em chamadas reduzidas a uma base de dados.



Colletion do tipo TYPE


SET SERVEROUTPUT ON
DECLARE
  TYPE EMP_RECORD_TYPE IS RECORD -- registros
        ( EMPLOYEE_ID hr.employees.employee_id%type,
          FIRST_NAME VARCHAR2(20),
          LAST_NAME  VARCHAR2(25)
        );
  V_EMP_RECORD EMP_RECORD_TYPE;
BEGIN

  SELECT EMPLOYEE_ID, FIRST_NAME, LAST_NAME INTO V_EMP_RECORD
  FROM HR.EMPLOYEES WHERE ROWNUM =1;
  
  DBMS_OUTPUT.PUT_LINE('Nome do empregado com ID ' || V_EMP_RECORD.EMPLOYEE_ID || ': ' || V_EMP_RECORD.FIRST_NAME || ' ' || V_EMP_RECORD.LAST_NAME);
END;

vantagens : uma linha somente para carregar tudo em uma variavel somente.
somente funciona para uma linha.


Colletion do tipo RowType

SET SERVEROUTPUT ON
DECLARE  
  EMP_RECORD HR.EMPLOYEES%ROWTYPE;
BEGIN
  SELECT  *  INTO EMP_RECORD -- tem que pegar todas as colunas.
  FROM    HR.EMPLOYEES WHERE ROWNUM =1;
  
  DBMS_OUTPUT.PUT_LINE('Nome do empregado com ID ' || EMP_RECORD.EMPLOYEE_ID || ': ' || EMP_RECORD.FIRST_NAME || ' ' || EMP_RECORD.LAST_NAME);
END;

-- fora a pegar todas as colunas da tabela apesar de ser mais simples.
-- somente funciona para uma linha.

Colletion index by table

O uso das matrizes associativas  necessrio quando:

Temos que armazenar os dados do programa em cache temporariamente em um formato de matriz para fins de pesquisa.
Quando precisamos de sequncia de caracteres para os elementos subscritos da coleo. Um ponto importante a ser informado 
 que ele tambm aceita ndices negativos.


SET SERVEROUTPUT ON
DECLARE
  TYPE v_emp_tab_type IS TABLE OF VARCHAR2(50) INDEX BY BINARY_INTEGER;  
  v_emp_tab  v_emp_tab_type;
  i number;
BEGIN  
  -- Popula a collection
  FOR i IN 1 .. 1000 LOOP
    v_emp_tab(i)  := 'EMPREGADO ' || to_char(i);
  END LOOP;
  
  -- loop p/ ler dados da collection (necessario WHILE c/ collection.next para ler chaves nao sequenciais    
  i := v_emp_tab.FIRST;  
  WHILE i IS NOT NULL 
  LOOP
    DBMS_OUTPUT.PUT_LINE('Empregado ' || I || ': ' ||  v_emp_tab(i));  
    i := v_emp_tab.NEXT(i);
 END LOOP;  
END;

somente aceita integer e varchar2
somente traz 2 resultados, id e uma coluna
praticamente nao  muito usada.
somente usado para calculos e demais coisas, aprendizado mais academico.

-- Colletion do tipo Varray
SET SERVEROUTPUT ON
DECLARE
  TYPE emp_type IS VARRAY(107) OF HR.EMPLOYEES%ROWTYPE; -- atribuir tamanho do array com total de linhas da tabela (SELECT COUNT(1) FROM HR.EMPLOYEES)
  V_EMP_RECORD emp_type;
BEGIN
  SELECT  * BULK COLLECT INTO V_EMP_RECORD --
  FROM    HR.EMPLOYEES;
  
  FOR I IN V_EMP_RECORD.first .. V_EMP_RECORD.last LOOP
    DBMS_OUTPUT.PUT_LINE('O nome do empregado com ID ' || V_EMP_RECORD(I).EMPLOYEE_ID || ' eh: ' || V_EMP_RECORD(I).FIRST_NAME || ' ' || V_EMP_RECORD(I).LAST_NAME);
  END LOOP;  
END;

select count(*) from hr.employees


Devemos utilizar as Varrays quando:

Temos que armazenar o volume calculado ou pr-definido de dados no banco de dados. O varray oferece um armazenamento 
limitado e definido de linhas em uma coleo. A ordem dos elementos tem que ser preservada.
Como bem vimos, os varrays so uma melhor opo vistos quando temos o numero de elementos conhecido com antecedncia.

O ponto negativo de sua utilizao  devido ao fato de no ser possvel  realizao de insero, deleo ou edio 
em seus elementos individuais.

-- pode ter n colunas mas o problema  que tem que alegar tanto de linhas no varray.
-- coletion apesar de ser mais rapido pode estourar memoria.


Colletions Nested Table

SET SERVEROUTPUT ON
DECLARE
  TYPE emp_type IS TABLE OF HR.EMPLOYEES%ROWTYPE;
  V_EMP_RECORD emp_type;
BEGIN
  SELECT  * BULK COLLECT INTO V_EMP_RECORD
  FROM    HR.EMPLOYEES; --sobe pra memoria somente a quantidade deste resultado de select
  
  FOR I IN V_EMP_RECORD.first .. V_EMP_RECORD.last LOOP
    DBMS_OUTPUT.PUT_LINE('Nome do empregado com ID ' || V_EMP_RECORD(I).EMPLOYEE_ID || ': ' || V_EMP_RECORD(I).FIRST_NAME || ' ' || V_EMP_RECORD(I).LAST_NAME);
  END LOOP;  
END;

Com relao a tabelas aninhadas, devemos us-las quando:

Temos que armazenar dados como conjuntos no banco de dados. Colunas do banco de dados do tipo tabela aninhada podem ser 
declaradas para armazenar os dados persistentes.
Realizao de grandes operaes da matriz, tais como insero e excluso, por um grande volume de dados.


-- mais util
-- nao tem tamanho pre definido.
-- problema  que isso sobre para a memoria, usar coletion tem que ter memoria sobrando pois sobre uma tabela de 1 gb sobe pra memoria.


Operadores Set para Colletions  - livro pagina 251 Oracle pl/sql Programao 11g Michel Laughlin

Cardinality, empty, member of, multiset except, multiset intersect, multiset union, set, submultiset

Exemplo de Cardinality

declare
  a lista := lista(1,2,3,3,4,4);
begin
  dbms_output.put_line(cardinality(set(a)));
end;


Acesso mais simples as colees COLEO API 
First, last, Next, Prior, Count, Delete, Exists, Extend, limit, Next(n), Prior(n), Trim.

SET SERVEROUTPUT ON
DECLARE
  TYPE emp_type IS TABLE OF HR.EMPLOYEES%ROWTYPE;
  EMP_COL emp_type;
BEGIN
  SELECT  * BULK COLLECT INTO EMP_COL
  FROM    HR.EMPLOYEES;
  
  IF NOT EMP_COL.EXISTS(10) THEN
    DBMS_OUTPUT.PUT_LINE('Nao existe o decimo elemento na colecao');
  END IF;
  
  DBMS_OUTPUT.PUT_LINE('Inicialmente existe(m) ' || TO_CHAR(EMP_COL.COUNT) || ' elemento(s) na colecao');  
  
  EMP_COL.TRIM(100); -- remove 100 ultimos elementos
  DBMS_OUTPUT.PUT_LINE('Total de elementos apos TRIM: ' || TO_CHAR(EMP_COL.COUNT));

  -- acrescenta elemento    
  EMP_COL.EXTEND;
  EMP_COL(EMP_COL.LAST).EMPLOYEE_ID := 300;
  EMP_COL(EMP_COL.LAST).FIRSt_name := 'PEDRO';
  EMP_COL(EMP_COL.LAST).last_name := 'CARVALHO';
  
  FOR I IN EMP_COL.FIRST .. EMP_COL.LAST
  LOOP
    DBMS_OUTPUT.PUT_LINE('O nome do empregado com ID ' || EMP_COL(I).EMPLOYEE_ID || ' eh: ' || EMP_COL(I).first_name || ' ' || EMP_COL(I).LAST_NAME);  
  END LOOP;
  
  EMP_COL.DELETE(4, 7);  -- Apaga elementos indice 4 ate 7 (delete sem parametro apaga todos os elementos)
  DBMS_OUTPUT.PUT_LINE('Total de elementos apos DELETE: ' || TO_CHAR(EMP_COL.COUNT));
      
  DBMS_OUTPUT.PUT_LINE('Total de elementos = ' || TO_CHAR(EMP_COL.COUNT) || '. Ultimo INDICE = ' || TO_CHAR(EMP_COL.LAST)); 
  
  FOR I IN EMP_COL.FIRST .. EMP_COL.LAST
  LOOP
    IF EMP_COL.EXISTS(I) THEN
      DBMS_OUTPUT.PUT_LINE('Nome do empregado com ID ' || EMP_COL(I).EMPLOYEE_ID || ': ' || EMP_COL(I).first_name || ' ' || EMP_COL(I).LAST_NAME);  
    END IF;
  END LOOP;
  
END;
