/* --------------------------------------------------------------------------------------------------------------------
                                            CURSO DE PROGRAMAO EM PL-SQL
                                                  PEDRO F. CARVALHO
                                              www.pedrofcarvalho.com.br
                                            contato@pedrofcarvalho.com.br
                                              ORACLE 9i, 10G, 11G E 12C
                         Preparao para a prova 1Z0-147 e 1Z0-144 e 1Z0-146 Program with PL/SQL  
----------------------------------------------------------------------------------------------------------------------*/


Captulo 09 - Usando Functions.

Functions ou Funes (em portugus) tambm so blocos PL/SQL nomeados, muito semelhantes s Stored Procedures.
A diferena principal  que as Funes obrigatoriamente devem retornar um valor. Procedures tambm podem retornar um 
valor mas no podem ser usadas diretamente em codigos SQL.

As funes so muito utilizadas para computar valores, promover reusabilidade e facilidade de manuteno e podem ser 
chamadas a partir de outros blocos PL/SQL ou at mesmo por instrues SQL.  muito comum utilizarmos funes em 
instrues SQL para efetuar converses de dados, formatar datas, contar o total de linhas, etc.

Exemplos de funes prontas no Oracle (SUM, AVG, MIN, MAX, COUNT e etc.)

Voc no pode usar funes definidas pelo usurio:

  Em uma clusula de restrio CHECK de um CREATE TABLE ou ALTER TABLE
  
  Em uma clusula DEFAULT de uma instruo CREATE TABLE ou ALTER TABLE
  
  Alm disso, quando uma funo  chamada a partir de uma instruo de consulta ou DML, a funo no pode:

  Tenha OUT ou IN OUT parmetros

  Confirmar ou reverter a transao atual, crie um ponto de salvamento ou reverter para um ponto de salvamento, ou alterar
  a sesso ou o sistema. DDL implicitamente confirmar a transao atual, portanto, uma funo definida pelo usurio no 
  pode executar nenhuma instruo DDL.
  
  Opes de Criaes de Funes :
  
  DETERMINISCT(RNDS, WNDS, RNPS, WNPS, TRUST) ou PARALLEL_ENABLED substituiem o antigo pr-compilado de instrues 
  RESTRICT_REFERENCES que limitava o que   as funes poderiam fazer quando elas estavam em pacotes.
  
  PIPELINE permite construir funes que retornam tabelas pipelined, essas tabelas agem como cursores. Melhoram o desempenho
  quando funes retornam colections, como tabelas aninhadas ou Varrays, cursores
  
  Oracle 11g introduziu o RESULT_CACHE onde o resultado da funo  armazenado em cache. Isso  a funo  chamada 
  apenas uma vez  na SGA e fica disponvel ao longo das sesses.
  
  PARALLEL_ENABLED permite atribuir uma funo para permitir capacidades de query paralelas.
  
  
  
  Exemplos
  
  -- 1: cria funcao HR.FC_EMPLOYEES_FORMATAR_EMAIL
DROP FUNCTION HR.FC_EMPLOYEES_FORMATAR_EMAIL
CREATE OR REPLACE FUNCTION HR.FC_EMPLOYEES_FORMATAR_EMAIL
    (p_email VARCHAR2) RETURN VARCHAR2 IS
  V_EMAIL  VARCHAR2(100);
BEGIN
    SELECT  p_email into V_EMAIL from dual 
    where   REGEXP_LIKE(p_email,'^([0-9a-zA-Z]+([_.-]?[0-9a-zA-Z]+)*@[0-9a-zA-Z]+[0-9,a-z,A-Z,.,-]*(.){1}[a-zA-Z]{2,4})+$');
    
    RETURN V_EMAIL;
EXCEPTION
  WHEN NO_DATA_FOUND THEN
      V_EMAIL := lower(p_email || '@pedrofcarvalho.com.br');
      RETURN V_EMAIL;
END;
/
-- 2: chama HR.FC_EMPLOYEES_RECUPERAR_EMAIL como parte de uma expressao SQL	
SELECT  E.FIRST_NAME, E.LAST_NAME,
        HR.FC_EMPLOYEES_FORMATAR_EMAIL(EMAIL) AS EMAIL
FROM    HR.EMPLOYEES E;



-- 1: criando a FC HR.FC_VALOR_COMISSAO
drop function HR.FC_VALOR_COMISSAO
CREATE OR REPLACE FUNCTION HR.FC_VALOR_COMISSAO
    (P_VL_SALARIO NUMBER, P_VL_COMISSAO NUMBER) RETURN NUMBER IS
  V_VL_COM_CALCULADA NUMBER;
 
BEGIN
    SELECT  ROUND(NVL(P_VL_COMISSAO,0) * P_VL_SALARIO,2) INTO V_VL_COM_CALCULADA
    FROM    DUAL;
    
    RETURN V_VL_COM_CALCULADA;
EXCEPTION
  WHEN OTHERS THEN
      V_VL_COM_CALCULADA := 0;
END;
/

-- 2: chamando a FC HR.FC_VALOR_COMISSAO
SELECT  FIRST_NAME||' '||LAST_NAME, 
        SALARY,        
        HR.FC_VALOR_COMISSAO(SALARY, commission_pct) AS VL_COMMISSION
from    HR.EMPLOYEES;

DROP FUNCTION HR.FC_INSERE_FUNC_SAL
CREATE OR REPLACE FUNCTION HR.FC_INSERE_FUNC_SAL(P_SAL NUMBER) RETURN NUMBER IS 
    v_sal number:=p_sal * 2;
   -- PRAGMA AUTONOMOUS_TRANSACTION;    
BEGIN
    INSERT INTO HR.EMPLOYEES (employee_id, last_name, email, hire_date, job_id, salary)
    VALUES (1013, 'carvalho', 'pedrofcarvalho4@yahoo.com', SYSDATE, 'IT_PROG',V_SAL);
   -- commit;
    return v_sal;
END;
/
 select * from hr.employees
 
-- erro ORA-04091 (tabela mutante)
UPDATE  HR.EMPLOYEES
SET     salary = hr.FC_INSERE_FUNC_SAL(200)
where hr.employees.employee_id = 1011;
commit;

DROP FUNCTION HR.FC_INSERE_FUNC_SAL;

SELECT  OWNER, OBJECT_NAME
FROM    ALL_OBJECTS -- DBA_OBJECT USER_OBJECT 
WHERE   OBJECT_TYPE = 'FUNCTION';

SELECT      owner, name, text
FROM        ALL_SOURCE 
WHERE       TYPE='FUNCTION'
ORDER BY    1,2,line;
  
Durante a instalao do banco de dados Oracle um script  executado automaticamente e cria toda a estrutura 
necessria para que as procedures sejam executadas. Eventualmente esse procedimento automtico pode falhar devido 
a alguma falha fsica no disco rgido, nesse caso o usurio SYS pode recriar a estrutura atravs do script 
SQL DBMSSTDX.SQL.

