/* --------------------------------------------------------------------------------------------------------------------
                                            CURSO DE PROGRAMAO EM PL-SQL
                                                  PEDRO F. CARVALHO
                                              www.pedrofcarvalho.com.br
                                            contato@pedrofcarvalho.com.br
                                              ORACLE 9i, 10G, 11G E 12C
                         Preparao para a prova 1Z0-147 e 1Z0-144 e 1Z0-146 Program with PL/SQL  
----------------------------------------------------------------------------------------------------------------------*/


Captulo 14 - Dependences - Subprograms.


Gerenciando Dependncias

A alterao de um objeto (tabela, viso, procedure, ...) pode afetar outros objetos e obrigar, no mnimo , 
a recompil-los. Assim, antes de iniciar a alterao  til verificar quais outros objetos podero ser afetados. 
Ou talvez muito antes disto, quando estiver avaliando custos e riscos de alterar o esquema para suportar um novo 
requisito. Para tanto, basta uma consulta a viso DBA_DEPENDENCIES (ou s equivalentes ALL_DEPENDENCIES  
e USER_DEPENDENCIES).

SELECT * FROM dba_dependencies 

SELECT * 
FROM dba_dependencies 
WHERE referenced_owner = 'HR'
  AND referenced_name = 'JOB_HISTORY';
  
Esta consulta retorna uma nica linha: a procedure ADD_JOB_HISTORY. Examinando o cdigo fonte desta procedure, 
nota-se que h um comando de INSERT na tabela. Parece-me razovel que, se voc incluir uma coluna na tabela, a 
procedure seja alteradap ara incluir um valor nesta nova coluna. E se por acaso remover uma coluna da tabela, a 
procedure obrigatoriamente ter que ser alterada.

Agora um passo a mais: como saber quais objetos a procedure pode afetar? Uma soluo simples seria aplicar novamente 
a mesma consulta, apenas usando o nome da procedure. Para um esquema simples, at pode ser, mas num esquema complexo, 
com centenas de objetos, seria um esforo manual desnecessrio e sujeito a erros. Muito mais conveniente e elegante  
usar a consulta abaixo e deixar que o Oracle resolva este problema. 

SELECT *
FROM dba_dependencies
START WITH referenced_owner = 'HR' 
       AND referenced_name  = 'JOB_HISTORY'
CONNECT BY prior owner = referenced_owner
       AND prior name  = referenced_name;   

A consulta retorna duas linhas: a procedure ADD_JOB_HISTORY e a trigger UPDATE_JOB_HISTORY, que tem uma chamada para a 
procedure. 

Descobrindo objetos descompilados

SELECT owner, object_type, object_name, status
FROM dba_objects
WHERE status != 'VALID'
-- AND upper(owner) = 'SEU_OWNER_EM_MAIUSCULO'
ORDER BY owner, object_type, object_name;

alter function hr.FC_EMPLOYEES_SALARY compile;

Subprogramas ver dideo aula.















